package solitaire;
import mWaba.*;
import mWaba.gui.*;
import mWaba.gui.control.*;
import mWaba.gui.graphics.*;
import waba.ui.*;
import waba.fx.*;

//##################################################################
public class SolitaireForm extends mForm {
//##################################################################

{
	exitSystemOnClose = true;
	title = "Solitaire";
	titleCancel = getButton("X");
}
public SolitaireBoard board;
MenuItem [] items;
public static mImage info,smallInfo;
mButton aboutButton;
public boolean amSmall;

//==================================================================
public SolitaireForm(boolean small)
//==================================================================
{
	amSmall = small;
	info = new mImage("Info.bmp","InfoMask.bmp");
	smallInfo = new mImage("SmallInfo.bmp","SmallInfoMask.bmp");
	addLast(new ScrollablePanel(board = new SolitaireBoard(small)));
}

//==================================================================
public void newBoard()
//==================================================================
{
	board.newBoard();
	board.refresh();
}
//==================================================================
public FormFrame getFormFrame()
//==================================================================
{
	FormFrame ff = super.getFormFrame();
	MenuBar mb = new MenuBar(); //mb.borderWidth = 1;
	Menu mn = mb.addMenu("Game").menu;
	items = mn.addItems(mString.split("New Board|Clear Board|-|Play Mode|Compose Mode|-|About|Exit"));
	ff.middleBar.addLast(mb);
	setupMenus();
	ff.rightButtons.addNext(aboutButton = new mButton());
	aboutButton.image = smallInfo;
	return ff;
}
//==================================================================
public void onEvent(Event ev)
//==================================================================
{
	if (ev instanceof MenuEvent) 
		onMenuEvent((MenuEvent)ev);
	else if (ev.type == ControlEvent.PRESSED && ev.target == aboutButton)
		about();
	super.onEvent(ev);
}
//==================================================================
public void setupMenus()
//==================================================================
{
	int ch = MenuItem.Checked;
	items[3].modifiers &= ~ch;
	items[4].modifiers &= ~ch;
	if (board.mode == board.PlayMode)
		items[3].modifiers |= ch;
	else
		items[4].modifiers |= ch;
}
//==================================================================
public void onMenuEvent(MenuEvent ev)
//==================================================================
{
	if (ev.selectedItem == items[0]) {
		board.newBoard();
		repaintNow();
	}else if (ev.selectedItem == items[1]) {
		board.clearBoard();
		repaintNow();
	}else if (ev.selectedItem == items[3]) {
		board.changeMode(board.PlayMode);
		setupMenus();
	}else if (ev.selectedItem == items[4]) {
		board.changeMode(board.ComposeMode);
		setupMenus();
	}else if (ev.selectedItem == items[6]){
		about();
	}else if (ev.selectedItem == items[7]){
		exit(0);
	}
}
String smallAboutString = "Waba(Beta 9) Solitaire\nMichael L Brereton\nmichael_brereton\n@\nhotmail.com"; 
String aboutString = "Waba(Beta 9) Solitaire\nMichael L Brereton\nmichael_brereton@hotmail.com";
//==================================================================
public void about()
//==================================================================
{
	String s = aboutString;
	if (amSmall) s = smallAboutString;
	MessageBox mb = new MessageBox("About",s,0);
	if (!amSmall) mb.icon = info;
	mb.exec(null,null);
}
//##################################################################
}
//##################################################################

